package view;

import java.util.ArrayList;

import java.util.List;

import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;

public class HistoryController {

    private List<HistoryEntry> history = new ArrayList();
    private int historySize = 10;
    private Object key;
    private String action;

    public HistoryController() {
    }


    public String doaction() {
        return action;
    }

    public void registerHistoryEntry(HistoryEntry entry) {
        // if this is another page than the currently last one or the key is different from the previous one
        // if the combination of page and key already exists in the history, then it should be moved to the top, otherwise it should be newly added at the top
        // find page, key in history; when found: remove
        int i = 0;
        for (HistoryEntry historyEntry: history) {
            if (historyEntry.getAction().equalsIgnoreCase(entry.getAction()))
                if (historyEntry.getKey().equals(entry.getKey())) {
                    break;
                }
            i++;
        }
        if (i < history.size()) {
            history.remove(i);
        }
        //then add the entry
        history.add(0, entry);
        
        // check if we have an overflow - more history than we care for
        if (history.size() > historySize) {
            List toremove = new ArrayList();
            toremove.addAll(history.subList(historySize, history.size()));
            history.removeAll(toremove);
        }
    }


    public void registerHistory(String displayLabel, Object key, String action, 
                                String qualifyingPages) {
        UIViewRoot newRoot = FacesContext.getCurrentInstance().getViewRoot();
        FacesContext fc = FacesContext.getCurrentInstance();

        if (qualifyingPages.indexOf(newRoot.getViewId()) > -1) {
            // if this is another page than the currently last one or the key is different from the previous one
            MethodBinding mb = 
                fc.getApplication().createMethodBinding("#{historyController.registerHistoryEntry}", 
                                                        new Class[] { HistoryEntry.class });
            mb.invoke(fc, 
                      new Object[] { new HistoryEntry(displayLabel, action, key) });

        }

    }

    public void setHistorySize(int historySize) {
        this.historySize = historySize;
    }

    public int getHistorySize() {
        return historySize;
    }

    public void setHistory(List<HistoryEntry> history) {
        this.history = history;
    }

    public List<HistoryEntry> getHistory() {
        return history;
    }

    public void setKey(Object key) {
        this.key = key;
    }

    public Object getKey() {
        return key;
    }

    public void setAction(String action) {
        this.action = action;
    }

    public String getAction() {
        return action;
    }
}
