package view;

import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import javax.faces.el.MethodBinding;

import oracle.jheadstart.controller.jsf.lifecycle.JhsPageLifecycle;

import oracle.adf.controller.v2.context.LifecycleContext;

import oracle.adf.model.BindingContext;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCParameter;

import oracle.jheadstart.controller.jsf.util.breadcrumbs.BreadcrumbManager;
import oracle.jheadstart.util.StringUtils;

public class HistoryEnabledLifeCycle extends JhsPageLifecycle {
    public HistoryEnabledLifeCycle() {
    }

    private final String PAGE_NAMES = "pagesToRecordHistoryFor";
    private final String DISPLAY_LABEL = "displayLabel";
    private final String KEY = "key";
    private final String ACTION = "action";

    public void prepareRender(LifecycleContext lfContext) {
        super.prepareRender(lfContext);
        FacesContext fc = FacesContext.getCurrentInstance();

        UIViewRoot newRoot = fc.getViewRoot();
        String qualifyingPages = (String)getParameter(PAGE_NAMES, lfContext);
        if (qualifyingPages != null && 
            qualifyingPages.indexOf(newRoot.getViewId()) > -1) {
            // this one qualifes
            System.out.println("REGISTER HISTORY ENTRY!!");

            String bcName = 
                lfContext.getBindingContainer() != null ? lfContext.getBindingContainer().getName() : 
                null;
            String displayLabel = 
                (String)getParameter(DISPLAY_LABEL, lfContext); //(String)fc.getApplication().createValueBinding(getParameter(DISPLAY_LABEL, lfContext)).getValue(fc);
            String action = 
                (String)getParameter(ACTION, lfContext); //(String)fc.getApplication().createValueBinding(getParameter(DISPLAY_LABEL, lfContext)).getValue(fc);
            Object key = 
                getParameter(KEY, lfContext); //(String)fc.getApplication().createValueBinding(getParameter(DISPLAY_LABEL, lfContext)).getValue(fc);
            System.out.println("REGISTER PAGE " + newRoot.getViewId() + 
                               " for " + displayLabel);


            MethodBinding mb = 
                fc.getApplication().createMethodBinding("#{historyController.registerHistoryEntry}", 
                                                        new Class[] { HistoryEntry.class });
            mb.invoke(fc, 
                      new Object[] { new HistoryEntry(displayLabel, action, key) });

        }
    } //prepareRender

    private Object getParameter(String parameterName, 
                                LifecycleContext lfContext) {
        DCBindingContainer currentContainer = 
            (DCBindingContainer)lfContext.getBindingContainer();
        DCParameter param = currentContainer.findParameter(parameterName);
        //       matrixBeans = StringUtils.stringToStringArray((String)param.getValue(),",");

        return param.getValue();
    }


}
